'**** bd_outline_max1.bas  rev 1.0 *****
'** Written by: Ron Olinyk 27.05.02
'** Usage: Program scans database for a valid bd outline
'**        retreives and displays it's max dimension points.
'** Note:  PPCB Ver 4.x+ required to run.
'**        Arc segments not supported.
'**        Cutouts excluded.

'Option Explicit

Dim x_ary() As Double
Dim y_ary() As Double

Sub Main
Dim bd_outln$, plines As Object, drw As Object, xycnt%
Dim geom As Object, n%, i%, unts$, max_x#, max_y#

If CDbl(Version) < 3.7 Then
  MsgBox "Program requires PPCB ver 4.x+. Aborting..",vbCritical,"Error"
  Exit Sub
End If

ReDim x_ary(1 To 100)
ReDim y_ary(1 To 100)
    Set plines = ActiveDocument.GetObjects(ppcbObjectTypeDrawing,,)
       For Each drw In plines
          If drw.DrawingType = ppcbDrwBoard Then
            bd_outln = drw.Name
            plines(bd_outln).selected = True
            Exit For
          End If
       Next drw   
   If bd_outln = "" Then
     MsgBox "Design does not contain a board outline",vbExclamation,"Error"
     Exit Sub
   End If  
   xycnt = 0
	 For Each geom In plines(bd_outln).Geometry          
	    If geom.ObjectType = ppcbObjectTypePolyline Then
		p = geom.Points 
		n = UBound(p, 1)          
		For i = 1 To n - 1            
		    If p(i, 3) = 0 Then                
		       x_ary(i + xycnt) = p(i, 1)
		       y_ary(i + xycnt) = p(i, 2)
		    End If  
        Next i
        End If
        xycnt = xycnt + i - 1
     Next geom
     ReDim Preserve x_ary(1 To xycnt)
     ReDim Preserve y_ary(1 To xycnt)
   Call sort_xary
   Call sort_yary
   unts = Unit_fncn()
   max_x = Abs(x_ary(UBound(x_ary)) - x_ary(LBound(x_ary)))
   max_y = Abs(y_ary(UBound(y_ary)) - y_ary(LBound(y_ary)))
   If unts = "mils" Then 
     max_x = Format(max_x/1000,"#.###")
     max_y = Format(max_y/1000,"#.###")
     unts = """
   End If
   MsgBox "Max Board Dimensions:" & vbCr _
          & "X = " & max_x & unts & vbCr _
          & "Y = " & max_y & unts,vbInformation,"Max Board Size"
End Sub

Sub sort_xary
Dim GotIt As Boolean, ix%, temp0#
GotIt = True
   While GotIt = True
	  GotIt = False
	  For ix = 1 To UBound(x_ary)-1  
	    If x_ary(ix) > x_ary(ix+1) Then	
	       temp0 = x_ary(ix)
	       x_ary(ix) = x_ary(ix+1)
		   x_ary(ix+1) = temp0
		   GotIt = True
		End If
	  Next ix
	Wend
End Sub

Sub sort_yary
Dim GotIt As Boolean, ix%, temp0#
GotIt = True
   While GotIt = True
	  GotIt = False
	  For ix = 1 To UBound(y_ary)-1  
	    If y_ary(ix) > y_ary(ix+1) Then	
	       temp0 = y_ary(ix)
	       y_ary(ix) = y_ary(ix+1)
		   y_ary(ix+1) = temp0
		   GotIt = True
		End If
	  Next ix
	Wend
End Sub

'************************
' Get Current Design Units
Private Function Unit_fncn() As String
Dim currUnit, currunitName$

	currUnit = ActiveDocument.unit
    If currUnit = 2 Then
      currunitName$ = "mils"
    ElseIf currUnit = 3 Then
      currunitName$ = "in."
    ElseIf currUnit = 4 Then
      currunitName$ = "mm"
    End If	
    Unit_fncn = currunitName
End Function
